﻿Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim dt As New DataTable()
        dt.Columns.Add("Name", GetType(String))
        dt.Columns.Add("Category", GetType(String))
        dt.Columns.Add("Sum of Total", GetType(Integer))

        dt.Rows.Add("Steve", "Beverages", 2500)
        dt.Rows.Add("Steve", "Condiments", 4500)
        dt.Rows.Add("Steve", "Confections", 9200)
        dt.Rows.Add("Lary", "Beverages", 3857)
        dt.Rows.Add("Lary", "Condiments", 4253)
        dt.Rows.Add("Lary", "Confections", 5144)

        c1TrueDBGrid2.DataSource = (dt)
        c1TrueDBGrid1.DataSource = GetInversedDataTable(dt, "Category", "Name", "Sum of Total", "", True)
    End Sub

    Public Function GetInversedDataTable(table As DataTable, columnX As String, columnY As String, columnZ As String, nullValue As String, sumValues As Boolean) As DataTable
        'Create a DataTable to Return
        Dim returnTable As New DataTable()

        If String.IsNullOrEmpty(columnX) Then
            columnX = table.Columns(0).ColumnName
        End If

        'Add a Column at the beginning of the table
        returnTable.Columns.Add(columnY)


        'Read all DISTINCT values from columnX Column in the provided DataTale
        Dim columnXValues As New List(Of String)()

        For Each dr As DataRow In table.Rows

            Dim columnXTemp As String = dr(columnX).ToString()
            If Not columnXValues.Contains(columnXTemp) Then
                'Read each row value, if it's different from others provided, add to the list of values and creates a new Column with its value.
                columnXValues.Add(columnXTemp)
                returnTable.Columns.Add(columnXTemp)
            End If
        Next

        'Verify if Y and Z Axis columns re provided
        If Not String.IsNullOrEmpty(columnY) AndAlso Not String.IsNullOrEmpty(columnZ) Then
            'Read DISTINCT Values for Y Axis Column
            Dim columnYValues As New List(Of String)()

            For Each dr As DataRow In table.Rows
                If Not columnYValues.Contains(dr(columnY).ToString()) Then
                    columnYValues.Add(dr(columnY).ToString())
                End If
            Next

            'Loop all Column Y Distinct Value
            For Each columnYValue As String In columnYValues
                'Creates a new Row
                Dim drReturn As DataRow = returnTable.NewRow()
                drReturn(0) = columnYValue
                'foreach column Y value, The rows are selected distincted
                Dim rows As DataRow() = table.[Select]((Convert.ToString((columnY & Convert.ToString("='"))) & columnYValue) + "'")

                'Read each row to fill the DataTable
                For Each dr As DataRow In rows
                    Dim rowColumnTitle As String = dr(columnX).ToString()

                    'Read each column to fill the DataTable
                    For Each dc As DataColumn In returnTable.Columns
                        If dc.ColumnName = rowColumnTitle Then
                            'If Sum of Values is True it try to perform a Sum
                            'If sum is not possible due to value types, the value displayed is the last one read
                            If sumValues Then
                                Try
                                    drReturn(rowColumnTitle) = Convert.ToDecimal(drReturn(rowColumnTitle)) + Convert.ToDecimal(dr(columnZ))
                                Catch
                                    drReturn(rowColumnTitle) = dr(columnZ)
                                End Try
                            Else

                                drReturn(rowColumnTitle) = dr(columnZ)
                            End If
                        End If
                    Next
                Next


                returnTable.Rows.Add(drReturn)
            Next
        Else
            Throw New Exception("The columns to perform inversion are not provided")
        End If

        'if a nullValue is provided, fill the datable with it
        If Not String.IsNullOrEmpty(nullValue) Then
            For Each dr As DataRow In returnTable.Rows
                For Each dc As DataColumn In returnTable.Columns
                    If String.IsNullOrEmpty(dr(dc.ColumnName).ToString()) Then
                        dr(dc.ColumnName) = nullValue
                    End If
                Next
            Next
        End If

        Return returnTable
    End Function
End Class
